/*

    SP: Paint progam
        ----- Sample for Xt -----

        by  k-chinen@is.aist-nara.ac.jp , 1994

	$Id: draw.c,v 1.2 1993/06/20 08:12:34 k-chinen Exp $
*/


#include "sp.h"

void clearpixmap(Display *dpy, Drawable drw, GC gc, int filler,
    int sx,int sy, int wx,int wy)
{
    int x,y;

    XSetForeground(dpy, gc, filler);
	for(x=sx;x<sx+wx;x++)
		XDrawPoint(dpy, drw, gc, x, sy);
	for(y=sy+1;y<sy+wy;y++)
		XCopyArea(dpy, drw, drw, gc, sx, sy, wx, 1, sx, y);
    XFlush(dpy);
}


/*
	----- Draw procedures -----
*/
void draw_pen(Display *d, Window w, GC g, int x,int y, int tx,int ty)
{
	XSetFillStyle(d,g,FillStippled);
	XSetStipple(d,g,pen_pix[pen]);
	XSetTSOrigin(d,g,
		x%pen_width[pen]-pen_width[pen]/2,y%pen_height[pen]-pen_height[pen]/2);
	XFillRectangle(d,w,g,x-pen_width[pen]/2,y-pen_height[pen]/2
		,pen_width[pen],pen_height[pen]);
	XSetTSOrigin(d,g,0,0);
}

void draw_point(Display *d, Window w, GC g, int x,int y, int tx,int ty)
{
	XSetFillStyle(d,g,FillSolid);
	XDrawPoint(d, w, g, x, y);
}

void draw_erase(Display *d, Window w, GC g, int x,int y, int tx,int ty)
{
	XSetForeground(d,g,white);
	XSetFillStyle(d,g,FillStippled);
	XSetStipple(d,g,pen_pix[pen]);
	XSetTSOrigin(d,g,
		x%pen_width[pen]-pen_width[pen]/2,y%pen_height[pen]-pen_height[pen]/2);
	XFillRectangle(d,w,g,x-pen_width[pen]/2,y-pen_height[pen]/2
		,pen_width[pen],pen_height[pen]);
	XSetTSOrigin(d,g,0,0);
	XSetForeground(d,g,col);
}


void draw_line(Display *d, Window w, GC g, int x,int y, int nx,int ny)
{
	XSetFillStyle(d,g,FillSolid);
	XDrawLine(d, w, g, x, y, nx, ny);
}

void draw_rect(Display *d, Window w, GC g, int x,int y, int nx,int ny)
{
	int tmp;

	if(nx<x) {
		tmp = x;
		x = nx;
		nx = tmp;
	}
	if(ny<y) {
		tmp = y;
		y = ny;
		ny = tmp;
	}
	XSetFillStyle(d,g,FillSolid);
    XDrawRectangle(d, w, g, x, y, nx-x, ny-y);
}

void draw_frect(Display *d, Window w, GC g, int x,int y, int nx,int ny)
{
	int tmp;

	if(nx<x) {
		tmp = x;
		x = nx;
		nx = tmp;
	}
	if(ny<y) {
		tmp = y;
		y = ny;
		ny = tmp;
	}
    XSetFillStyle(d,g,FillStippled);
    XSetStipple(d,g,fill_pix[fill]);

    XFillRectangle(d, w, g, x, y, nx-x, ny-y);
}

void draw_cir(Display *d, Window w, GC g, int x,int y, int nx,int ny)
{
	int tmp;

	if(nx<x) {
		tmp = x;
		x = nx;
		nx = tmp;
	}
	if(ny<y) {
		tmp = y;
		y = ny;
		ny = tmp;
	}
	XSetFillStyle(d,g,FillSolid);
    XDrawArc(d, w, g, x, y, nx-x, nx-x, 0, 64*360);
}
void draw_fcir(Display *d, Window w, GC g, int x,int y, int nx,int ny)
{
	int tmp;

	if(nx<x) {
		tmp = x;
		x = nx;
		nx = tmp;
	}
	if(ny<y) {
		tmp = y;
		y = ny;
		ny = tmp;
	}
    XSetFillStyle(d,g,FillStippled);
    XSetStipple(d,g,fill_pix[fill]);

    XFillArc(d, w, g, x, y, nx-x, nx-x, 0, 64*360);
}

void draw_ell(Display *d, Window w, GC g, int x,int y, int nx,int ny)
{
	int tmp;

	if(nx<x) {
		tmp = x;
		x = nx;
		nx = tmp;
	}
	if(ny<y) {
		tmp = y;
		y = ny;
		ny = tmp;
	}

	XSetFillStyle(d,g,FillSolid);
    XDrawArc(d, w, g, x, y, nx-x, ny-y, 0, 64*360);
}
void draw_fell(Display *d, Window w, GC g, int x,int y, int nx,int ny)
{
	int tmp;

	if(nx<x) {
		tmp = x;
		x = nx;
		nx = tmp;
	}
	if(ny<y) {
		tmp = y;
		y = ny;
		ny = tmp;
	}
	XSetFillStyle(d,g,FillStippled);
	XSetStipple(d,g,fill_pix[fill]);

    XFillArc(d, w, g, x, y, nx-x, ny-y, 0, 64*360);
}

void draw_spray(Display *d, Window w, GC g, int x,int y, int tx,int ty)
{
	int i,ry,gx,gy;
	static int j=491;

	/*
	srand(j++);
	*/

	srand(rand_seed);

	for(i=0;i<spray_count;i++) {
		gx = rand() % (spray_size*2) - spray_size;
		ry = sqrt((double)spray_size*spray_size - gx*gx);
		if(ry)
			gy = rand() % (ry*2) - ry;
		else
			gy = 0;
    	XDrawPoint(d, w, g, gx+x, gy+y);
	}
}

extern String text_string;

void draw_text(Display *d, Window w, GC g, int x,int y, int tx,int ty)
{
	text_string = XawDialogGetValueString(textentry);
	XSetFillStyle(d,g,FillSolid);
	XDrawString(d,w,g,x,y,text_string,(int)strlen(text_string));
}

void _draw_opt(Display *d, Window w, GC g, int x,int y, int tx,int ty)
{
	XImage *im;
	int i,j,k,h,ck;
	Pixel 	p,newcolor;
	XColor a,b,tmp;

	printf("$");
	/*
	tx = 5; ty = 5;
	*/
	tx = 20; ty = 20;
	im = XGetImage(d,w,x,y,tx,ty ,0xFFFFFFFF,XYPixmap);

	for(j=0;j<ty;j++)
		for(i=0;i<tx;i++) {
			p = XGetPixel(im,i,j);
			/*
			printf(" %02X",p);
			*/
			/*
			h = -1;
			for(k=0;k<lastcolor;k++) {
				if(color_value[k].pixel == p)
					h = k;
			}
			*/
			h=0;
			b.pixel = p;
			XQueryColor(d, cmap, &b);
			/*
			if(h>-1) {
			*/
				a = color_value[ncol]; /* col */
				/*
				b = color_value[h];
				*/
				tmp.red 	= (a.red 	+ b.red ) /2;
				tmp.green	= (a.green	+ b.green) /2;
				tmp.blue	= (a.blue	+ b.blue) /2;
				ck = XAllocColor(d,cmap,&tmp);
				newcolor 	= tmp.pixel;

				if(ck) {
					/*
					printf(";%2X",h);
					printf(":%2x,%2x,%2x", a.red,a.green,a.blue);
					printf(" %2x,%2x,%2x", b.red,b.green,b.blue);
					printf("->%2x,%2x,%2x",tmp.red,tmp.green,tmp.blue);
					putchar('\n');
					*/
					/*
					XSetForeground(d,g,newcolor);
					XDrawPoint(d,w,g,x+i,y+j);
					*/
					/* */
					XPutPixel(im,i,j,newcolor);
					/* */
				}
			/*
			}
			else
				putchar('*');
			*/
		}
	/* */
	XPutImage(d,w,g,im,0,0,x,y,tx,ty);
	/* */
	/*
	putchar('@');
	putchar('\n');
	*/

	XDestroyImage(im);
}

void draw_opt__(Display *d, Window w, GC g, int x,int y, int tx,int ty)
{
	XImage *im;
	int i,j,p;
	Pixel pa, pb ,newcolor;
	XColor a,b,c;

    im = XGetImage(dpy,w,
			x,y,image_buffer->width,image_buffer->height,AllPlanes,ZPixmap);

	for(j=0;j<image_buffer->height;j++)
	{
		for(i=0;i<image_buffer->width;i++)
		{
			pa = XGetPixel(im,i,j);
			pb = XGetPixel(image_buffer,i,j);
			a.pixel = pa;
			b.pixel = pb;
			XQueryColor(d, cmap, &a);
			XQueryColor(d, cmap, &b);
			c.red 	= (a.red 	+ b.red )	/2;
			c.green	= (a.green	+ b.green)	/2;
			c.blue	= (a.blue	+ b.blue)	/2;

			p = XAllocColor(d,cmap,&c);
			newcolor = c.pixel;

			XPutPixel(im,i,j,newcolor);
		}
	}

	XPutImage(dpy,w,g,im,
		0,0,x,y,image_buffer->width,image_buffer->height);

	XDestroyImage(im);
}

void draw_opt(Display *d, Window w, GC g, int x,int y, int tx,int ty)
{
	XImage *im;
	int i,j,p;
	Pixel pa, pb ,newcolor;
	XColor a,b,c;

    im = XGetImage(dpy,w,
			x,y,image_buffer->width,image_buffer->height,AllPlanes,ZPixmap);

	for(j=0;j<image_buffer->height;j+=2)
	{
		for(i=0;i<image_buffer->width;i+=2)
		{
			pb = XGetPixel(image_buffer,i,j);
			XPutPixel(im,i,j,pb);
		}
	}

	XPutImage(dpy,w,g,im,
		0,0,x,y,image_buffer->width,image_buffer->height);

	XDestroyImage(im);
}
