/*

    SP: Paint progam
        ----- Sample for Xt -----

        by  k-chinen@is.aist-nara.ac.jp , 1994

	$Id: edit.c,v 1.1 1993/05/07 01:48:15 k-chinen Exp $
*/


#include "sp.h"

#undef USE_XCMS

#ifdef USE_XCMS
#include <X11/Xcms.h>
#endif

#include "namelevel.h"

/* public */
Widget edit_spray_shell;

/* private */
static Widget edit_spray_base;
static Widget edit_spray_canvas, edit_spray_buttonlist;
static Widget edit_spray_close;
static Widget edit_spray_size, edit_spray_count;

/*
static XcmsColor XC;
*/

static void edit_Fresh(Widget w, XtPointer a, XtPointer v)
{
#if 1
	Status	s;

	XtVaGetValues(edit_spray_count, XtNlevel,	&spray_count, NULL);
	XtVaGetValues(edit_spray_size, XtNlevel,	&spray_size, NULL);

	/*
	printf("B size %d, count %d\n", spray_size, spray_count);
	*/
	if(spray_size<=0)	spray_size = 1;

	/*
    clearpixmap(XtDisplay(edit_spray_canvas), XtWindow(edit_spray_canvas),
		copyGC, white, 0, 0, 200, 200);
	*/

    XSetForeground(XtDisplay(edit_spray_canvas), copyGC, white);
    XSetFillStyle(XtDisplay(edit_spray_canvas),copyGC,FillSolid);
    XFillRectangle(XtDisplay(edit_spray_canvas),XtWindow(edit_spray_canvas),
		copyGC, 0,0, CANVAS_WIDTH, CANVAS_HEIGHT);

    XSetForeground(XtDisplay(edit_spray_canvas), copyGC, col);
	draw_spray(XtDisplay(edit_spray_canvas),XtWindow(edit_spray_canvas),
		copyGC,100,100,0,0);

	/*
	XFlush(XtDisplay(edit_spray_canvas));
	*/

#else
	int	i,j;
	XcmsFloat h,c,v;
	XcmsFloat hp,cp,vp;

	h = 0.0;	hp	= 360.0/10;
	for(i=0;i<10;i++) {
		c = 0.0;	cp	= 100.0/10;
		for(j=0;j<10;j++) {
			XC.spec.TekHVC.H = h;
			XC.spec.TekHVC.C = c;
			XC.spec.TekHVC.V = 50.0;

			s = XcmsAllocColor(dpy,cmap,&XC,XcmsTekHVCFormat);
			printf("%2d,%2d:(%d) H C V = (%f %f %f) ->%3d\n",i,j,s,
				XC.spec.TekHVC.H,XC.spec.TekHVC.C,XC.spec.TekHVC.V,XC.pixel);

			XSetForeground(dpy,copyGC,XC.pixel);
			XDrawRectangle(dpy,XtWindow(canvas),copyGC,
				i*10,j*10,10,10);

			c += cp;
		}
		h += hp;
	}
	XFlush(XtDisplay(edit_spray_canvas));
#endif
}

static void edit_Close(Widget w, XtPointer a, XtPointer v)
{
	XtUnrealizeWidget(edit_spray_shell);
}

void init_edit_spray()
{
    edit_spray_shell = XtAppCreateShell(
        "Sp","EditSpray",
        topLevelShellWidgetClass,XtDisplay(toplevel),
        NULL,0);
    XtVaSetValues(edit_spray_shell,
        XtNtitle, "Edit Spray",
        NULL);
    edit_spray_base = XtVaCreateManagedWidget(
        "SprayBase", boxWidgetClass, edit_spray_shell, NULL);
    edit_spray_canvas = XtVaCreateManagedWidget(
        "Spray", boxWidgetClass, edit_spray_base, NULL);
    XtVaSetValues(edit_spray_canvas,
        XtNwidth, 200,
        XtNheight, 200,
        NULL);
    edit_spray_buttonlist = XtVaCreateManagedWidget(
        "Spray", boxWidgetClass, edit_spray_base, NULL);
    XtVaSetValues(edit_spray_buttonlist,
        XtNborderWidth, 0,
        XtNorientation, XtorientVertical,
        NULL);
    edit_spray_size = XtVaCreateManagedWidget(
        "Buttonlist", levelWidgetClass, edit_spray_buttonlist,
		XtNname,	"Size  :",
		XtNorientation,	XtEhorizontal,
		XtNlevel,	spray_size,
		XtNlevelMax,	100,
		XtNlevelMin,	0,
        XtNwidth, 		180,
		NULL);
	XtAddCallback(edit_spray_size, XtNcallback, edit_Fresh, NULL);
    edit_spray_count = XtVaCreateManagedWidget(
        "Buttonlist", levelWidgetClass, edit_spray_buttonlist,
		XtNname,	"Count :",
		XtNorientation,	XtEhorizontal,
		XtNlevel,	spray_count,
		XtNlevelMax,	100,
		XtNlevelMin,	0,
        XtNwidth, 		180,
		NULL);
	XtAddCallback(edit_spray_count, XtNcallback, edit_Fresh, NULL);
    edit_spray_close = XtVaCreateManagedWidget(
        "Spray", commandWidgetClass, edit_spray_buttonlist,
        XtNlabel, "Close",
        NULL);
	XtAddCallback(edit_spray_close, XtNcallback, edit_Close, NULL);
}

void start_edit_spray()
{
    XtRealizeWidget(edit_spray_shell);
	edit_Fresh(NULL,NULL,NULL);
}
