/*

    SP: Paint progam
        ----- Sample for Xt -----

        by  k-chinen@is.aist-nara.ac.jp , 1994

    $Id$
*/


#include "sp.h"

void Quit_program(Widget w, XtPointer client_data, XtPointer call_data)
{
	exit(0);
}

void write_xwdfile(char *name, Window w, int wid, int ht)
{
	char tmp[STRLEN];

	/*
	fprintf(stderr,"w            = %#x\n",w);
	fprintf(stderr,"canvas       = %#x\n",XtWindow(canvas));
	fprintf(stderr,"canvas_base  = %#x\n",XtWindow(canvas_base));
	*/

	sprintf(tmp,"xwd -id %#x -nobdrs -out %s",w,name);
	/*
	fprintf(stderr,"call <%s>\n",tmp);
	*/
	system(tmp);
}


extern void write_tifffile(char *name, Drawable dp, int w, int h);
extern void write_colorepsfile(char *name, Drawable dp, int w, int h);
extern void write_monoepsfile(char *name, Drawable dp, int w, int h);

void (*writefile)()=write_colorepsfile;

String	file_name;
static int	colortype=1;

void Done_export_eps(Widget w, XtPointer client_data, XtPointer call_data)
{
	int wid,ht;

	file_name = XawDialogGetValueString(file_name_entry);
	XtPopdown(file_name_shell);

	XtVaGetValues(canvas, XtNwidth, &wid, XtNheight, &ht, NULL);

	/*
	printf("<%s> %dx%d\n",file_name,wid,ht);
	printf("canvas size %dx%d\n",canvas_width,canvas_height);
	printf("canvas pos  %dx%d\n",canvas_x,canvas_y);
	*/

	/*
	if(strcmp(file_name,"")==0) {
		switch(colortype) {
		case 0: write_xwdfile("noname.xwd",XtWindow(canvas),wid,ht);
				break;
		case 1:	write_colorepsfile("noname.eps",XtWindow(canvas),wid,ht);
				break;
		case 2:	write_monoepsfile("noname.eps",XtWindow(canvas),wid,ht);
				break;
		}
	}
	else {
		switch(colortype) {
		case 0: write_xwdfile(file_name,XtWindow(canvas),wid,ht);
				break;
		case 1: write_colorepsfile(file_name,XtWindow(canvas),wid,ht);
				break;
		case 2:	write_monoepsfile(file_name,XtWindow(canvas),wid,ht);
				break;
		}
	}
	*/
	if((void*)writefile==(void*)write_xwdfile) {
		/*
		fprintf(stderr,"\nXWD format\n");
		*/
		if(strcmp(file_name,"")==0)
			writefile("noname.xwd",XtWindow(canvas),wid,ht);
		else
			writefile(file_name,XtWindow(canvas),wid,ht);
	}
	else {
		if(strcmp(file_name,"")==0)
			writefile("noname.xwd",canvas_store,wid,ht);
		else
			writefile(file_name,canvas_store,wid,ht);
	}
}

void Canel_export_eps(Widget w, XtPointer client_data, XtPointer call_data)
{
	XtPopdown(file_name_shell);
}

void Export_MONOeps(Widget w, XtPointer client_data, XtPointer call_data)
{
	writefile=write_monoepsfile;
	colortype=2;
	XtPopup(file_name_shell, XtGrabNonexclusive);
}

void Export_COLOReps(Widget w, XtPointer client_data, XtPointer call_data)
{
	writefile=write_colorepsfile;
	XtPopup(file_name_shell, XtGrabNonexclusive);
}

void Save_canvas(Widget w, XtPointer client_data, XtPointer call_data)
{
	writefile=write_xwdfile;
	XtPopup(file_name_shell, XtGrabNonexclusive);
}

void Redraw_canvas(Widget w, XEvent *eve, String *par, Cardinal *npar)
{
	XtVaGetValues(canvas, XtNwidth, &canvas_width,
		XtNheight, &canvas_height, NULL);
	
	XCopyArea(XtDisplay(canvas), canvas_store, XtWindow(canvas), copyGC,
		canvas_x, canvas_y, canvas_width, canvas_height, 0, 0);
}


void Clear_canvas(Widget w, XtPointer client_data, XtPointer call_data)
{
	XSetForeground(XtDisplay(canvas), copyGC, white);
	XSetFillStyle(XtDisplay(canvas),copyGC,FillSolid);

	XFillRectangle(XtDisplay(canvas),canvas_store,copyGC,
		0,0, CANVAS_MAXWIDTH, CANVAS_MAXHEIGHT);
	XCopyArea(XtDisplay(canvas), canvas_store, XtWindow(canvas), copyGC,
		canvas_x, canvas_y, canvas_width, canvas_height, 0, 0);
}


void Scroll_canvas(Widget w, XtPointer client_data, XtPointer call_data)
{
	int position = (int)call_data;
	Dimension wid;
	float percent,len;
	float range;

	XtVaGetValues(w,XtNlength,&wid,NULL);
	/*
	printf("Scroll :lenght %d\n");
	printf("widget %p : %d / %d",w,position,wid);
	*/
	if(w==canvas_hscroll) {
		range = (float)(CANVAS_MAXWIDTH-wid)/((float)CANVAS_MAXWIDTH);
		len = (float)(wid)/((float)CANVAS_MAXWIDTH);
		percent = ((float) canvas_x / (float)CANVAS_MAXWIDTH);

		/*
		printf(", canvas_x = %d / %f / %f\n",canvas_x,percent,range);
		*/
		if(position<0) {
			percent += 0.1;
			if(percent>=range) percent = range;
		}
		else {
			percent -= 0.1;
			if(percent<=0.00) percent = 0.000;
		}
		/*
		printf("now %f, %f\n",percent, range);
		*/
		canvas_x = (int) (percent*CANVAS_MAXWIDTH);
		/*
		printf("canvas_x = %d\n",canvas_x);
		*/
	}
	else {
		range = (float)(CANVAS_MAXHEIGHT-wid)/((float)CANVAS_MAXHEIGHT);
		len = (float)(wid)/((float)CANVAS_MAXHEIGHT);
		percent = ((float) canvas_y / (float)CANVAS_MAXHEIGHT);

		/*
		printf(", canvas_x = %d / %f / %f\n",canvas_y,percent,range);
		*/
		if(position<0) {
			percent += 0.1;
			if(percent>=range) percent = range;
		}
		else {
			percent -= 0.1;
			if(percent<=0.00) percent = 0.000;
		}
		/*
		printf("now %f, %f\n",percent, range);
		*/
		canvas_y = (int) (percent*CANVAS_MAXHEIGHT);
		/*
		printf("canvas_y = %d\n",canvas_y);
		*/
	}

	XawScrollbarSetThumb(w, percent, len);

	/*
	printf("[ %d,%d ]\n",canvas_x, canvas_y);
	*/

	Redraw_canvas(canvas,(XEvent*)NULL,(String*)NULL, (Cardinal*)NULL);
}

void Jump_canvas(Widget w, XtPointer client_data, XtPointer call_data)
{
    float percent = *(float*) call_data;
	Dimension	wid;
	float len, range;

	XtVaGetValues(w,XtNlength,&wid,NULL);
	/*
	printf("Jump scroll:lenght %d\n");
	*/

	if(w==canvas_hscroll) {
		range = (float)(CANVAS_MAXWIDTH-wid)/((float)CANVAS_MAXWIDTH);
		if(percent<0.0)		percent = 0.0;
		if(percent>=range)	percent = range;
		canvas_x = (int)((float) CANVAS_MAXWIDTH * percent);

		len = (float)(wid)/((float)CANVAS_MAXWIDTH);
	}
	else {
	if(w==canvas_vscroll)
		range = (float)(CANVAS_MAXHEIGHT-wid)/((float)CANVAS_MAXHEIGHT);
		if(percent<0.0)		percent = 0.0;
		if(percent>=range)	percent = range;
		canvas_y = (int)((float) CANVAS_MAXHEIGHT * percent);

		len = (float)(wid)/((float)CANVAS_MAXHEIGHT);
	}

	XawScrollbarSetThumb(w, percent, len);

	/*
	prntf("       after  %p : %f\n",w,percent);
	printf("[ %d,%d ]\n",canvas_x, canvas_y);
	*/

	Redraw_canvas(canvas,(XEvent*)NULL,(String*)NULL, (Cardinal*)NULL);
}


void Solidfill_canvas(Widget w, XtPointer client_data, XtPointer call_data)
{
	XSetForeground(XtDisplay(canvas), copyGC, col);
	XSetFillStyle(XtDisplay(canvas),copyGC,FillSolid);

	XFillRectangle(XtDisplay(canvas),canvas_store,copyGC,
		canvas_x,canvas_y, CANVAS_MAXWIDTH, CANVAS_MAXHEIGHT);
	XFillRectangle(XtDisplay(canvas),XtWindow(canvas),copyGC,
		0,0, canvas_width, canvas_height);
}




void Fill_canvas(Widget w, XtPointer client_data, XtPointer call_data)
{
	XSetForeground(XtDisplay(canvas), copyGC, col);
	XSetFillStyle(XtDisplay(canvas),copyGC,FillStippled);
	XSetStipple(XtDisplay(canvas),copyGC,fill_pix[fill]);

	XFillRectangle(XtDisplay(canvas),canvas_store,copyGC,
		canvas_x,canvas_y, CANVAS_MAXWIDTH, CANVAS_MAXHEIGHT);
	XFillRectangle(XtDisplay(canvas),XtWindow(canvas),copyGC,
		0,0, canvas_width, canvas_height);
}




void Wake_sample(Widget w, XtPointer client_data, XtPointer call_data)
{
	XtRealizeWidget(sample_shell);
}

void Clearsample(Widget w, XtPointer client_data, XtPointer call_data)
{
	unsigned int wid,ht;

	XtVaGetValues(canvas, XtNwidth, &wid, XtNheight, &ht, NULL);

	XSetForeground(XtDisplay(canvas), copyGC, white);
	XSetFillStyle(XtDisplay(canvas),copyGC,FillSolid);

	XFillRectangle(XtDisplay(sample_canvas),XtWindow(sample_canvas),copyGC,
		0,0, wid, ht);
}




void Pickwindow(Widget w,XtPointer client_data,XtPointer call_data)
{
    XWindowAttributes xwa;
    Status status;
	Window target;
	int	x,y;
	int wid,ht;

	if(pick_window(&target, &x, &y))
		return;

	if(image_buffer!=(XImage*)NULL)
		XDestroyImage(image_buffer);

    status = XGetWindowAttributes(dpy, target, &xwa);
	image_buffer = XGetImage(dpy,target,0,0,xwa.width,xwa.height,AllPlanes,ZPixmap);
}

void Cutimage(Widget w,XtPointer client_data,XtPointer call_data)
{
	Window target;
	int	x,y,wid,ht;

	if(pick_area(&target, &x, &y, &wid, &ht)) {
		return;
	}

	if(image_buffer!=(XImage*)NULL)
		XDestroyImage(image_buffer);
	image_buffer = XGetImage(dpy,root,x,y,wid,ht,AllPlanes,ZPixmap);
}

int get_pos(Window w, int *x, int *y);

void Pasteimage(Widget w,XtPointer client_data,XtPointer call_data)
{
	int x,y,c;

	if(image_buffer==(XImage*)NULL) {
		/* no image */
		/*
		printf("PUTIMAGE: no image\n");
		*/
		return;
	}

	/*
	while(!get_pos(XtWindow(canvas),&x,&y)) {
	*/

	if(!get_pos(XtWindow(canvas),&x,&y)) {
		XPutImage(dpy,XtWindow(canvas),copyGC,image_buffer,
			0,0,x,y,image_buffer->width,image_buffer->height);
		XPutImage(dpy,canvas_store,copyGC,image_buffer,
			0,0,x,y,image_buffer->width,image_buffer->height);
	}
}

void Pickcolor(Widget w,XtPointer client_data,XtPointer call_data)
{
	col = pick_color();

	XtVaSetValues(nowcolor,
		XtNbackground, col,
		NULL);
}








Pixel old_col=0;

void Setcolor(Widget w, XtPointer client_data, XtPointer call_data)
{
	XtVaSetValues(ele_color[old_col],
		XtNborderColor, color_value[old_col].pixel,
		XtNbackground, color_value[old_col].pixel,
		XtNbackgroundPixmap, XtUnspecifiedPixmap,
		NULL);
	
	ncol = (Pixel) client_data;
	col = color_value[ncol].pixel;

	XtVaSetValues(ele_color[ncol],
		XtNbackgroundPixmap, select_mark,
		XtNbackground, col,
		NULL);
	old_col = ncol;

	XtVaSetValues(nowcolor,
		XtNbackground, col,
		NULL);
	old_col = ncol;
}

void Setobj(Widget w, XtPointer client_data, XtPointer call_data)
{
	XtVaSetValues(ele_obj_label[obj],
		XtNforeground,black,
		XtNbackground,white,
		NULL);

	obj = (objtype) client_data;

	switch(obj) {
	case PEN:		drawfunc = draw_pen;	break;
	case POINT:		drawfunc = draw_point;	break;

	case ERASE:		drawfunc = draw_erase;	break;

	case SPRAY:		drawfunc = draw_spray;	break;
	case LINE:		drawfunc = draw_line;	break;
	case TEXT:		drawfunc = draw_text;	break;

	case RECT:		drawfunc = draw_rect;	break;
	case CIR:		drawfunc = draw_cir;	break;
	case ELL:		drawfunc = draw_ell;	break;

	case FRECT:		drawfunc = draw_frect;	break;
	case FCIR:		drawfunc = draw_fcir;	break;
	case FELL:		drawfunc = draw_fell;	break;
	case OPT:		drawfunc = draw_opt;	break;
	defaults:	drawfunc = draw_point;	break;
	}

	XtVaSetValues(ele_obj_label[(int)client_data],
		XtNforeground,white,
		XtNbackground,black,
		NULL);
}


void Editobj(Widget w, XtPointer client_data, XtPointer call_data)
{
	objtype obj = (objtype) client_data;

	switch(obj) {
	/*
	case PEN:		drawfunc = draw_pen;	break;
	case POINT:		drawfunc = draw_point;	break;
	*/
	case SPRAY:
			/*
			XtRealizeWidget(edit_spray_shell);
			*/
			start_edit_spray();
			break;
	/*
	case LINE:		drawfunc = draw_line;	break;
	case TEXT:		drawfunc = draw_text;	break;

	case RECT:		drawfunc = draw_rect;	break;
	case CIR:		drawfunc = draw_cir;	break;
	case ELL:		drawfunc = draw_ell;	break;

	case FRECT:		drawfunc = draw_frect;	break;
	case FCIR:		drawfunc = draw_fcir;	break;
	case FELL:		drawfunc = draw_fell;	break;
	case OPT:		drawfunc = draw_opt;	break;
	defaults:	drawfunc = draw_point;	break;
	*/
	}
}

void Setpen(Widget w, XtPointer client_data, XtPointer call_data)
{
	/*
	Setobj(ele_obj_label[(int)PEN],(XtPointer)PEN,(XtPointer) NULL);
	*/

	pen = (int)client_data;
}

void Setfill(Widget w, XtPointer client_data, XtPointer call_data)
{
	fill = (int)client_data;
}


String   text_string;

static Display  *text_d;
static Window   text_w;
static GC       text_gc;
static int      text_x, text_y;

/*
void Done_text(Widget w, XEvent *eve, String *parms, Cardinal *num_parm)
{
    text_string = XawDialogGetValueString(textentry);
    XtPopdown(textshell);

    font = XLoadFont(text_d, "fixed");
    XSetFont(text_d,text_gc,font);

    XDrawString(text_d,text_w,text_gc,
        text_x,text_y,text_string,(int)strlen(text_string));
	if(text_w==XtWindow(canvas))
		XDrawString(text_d,canvas_store,text_gc,
			canvas_x+text_x,canvas_y+text_y,text_string,(int)strlen(text_string));
}
*/

void Done_textentry(Widget w, XtPointer client_data, XtPointer call_data)
{
    text_string = XawDialogGetValueString(textentry);
    XtPopdown(textshell);

    XSetFillStyle(text_d,text_gc,FillSolid);
    XDrawString(text_d,text_w,text_gc,
        text_x,text_y,text_string,(int)strlen(text_string));
	if(text_w==XtWindow(canvas))
		XDrawString(text_d,canvas_store,text_gc,
			text_x,text_y,text_string,(int)strlen(text_string));
}

void Draw(Widget w, XEvent *eve, String *parms, Cardinal *num_parm)
{
	XSetForeground(XtDisplay(canvas), copyGC, col);

	sx = eve->xbutton.x;
	sy = eve->xbutton.y;

	next_seed();

	if(obj==OPT) {
		indraw = True;
		return;
	}
		
	if(obj==TEXT) {
		text_d  = XtDisplay(canvas);
		text_w  = XtWindow(w);
		text_gc = copyGC;
		text_x  = sx;
		text_y  = sy;

		XtPopup(textshell, XtGrabNonexclusive);
		return;
	}

	if(obj==PEN || obj==POINT || obj==ERASE|| obj==SPRAY || obj==OPT) {
		drawfunc(XtDisplay(canvas), XtWindow(w), copyGC,
			sx, sy, ex,ey);
		if(w==canvas)
			drawfunc(XtDisplay(canvas), canvas_store, copyGC,
				canvas_x+sx, canvas_y+sy, canvas_x+ex, canvas_y+ey);
	}

	indraw = True;
	ex = sx;
	ey = sy;
	drawfunc(XtDisplay(canvas), XtWindow(w), copyGC,
		sx, sy, ex,ey);
}

void Halt(Widget w, XEvent *eve, String *parms, Cardinal *num_parm)
{
	if(indraw) {
		XSetForeground(XtDisplay(canvas), xorGC, col);
		if(obj!=PEN && obj!=POINT && obj!=ERASE
			&& obj!=SPRAY && obj!=OPT) {
			drawfunc(XtDisplay(canvas), XtWindow(w), xorGC,
				sx, sy, ex,ey);
			if(w==canvas)
				drawfunc(XtDisplay(canvas), canvas_store, xorGC,
					canvas_x+sx, canvas_y+sy, canvas_x+ex, canvas_y+ey);
			}
		indraw = False;
	}
}

void Done(Widget w, XEvent *eve, String *parms, Cardinal *num_parm)
{
	if(!indraw)
		return;

	indraw = False;
	next_seed();
	XSetForeground(XtDisplay(canvas), copyGC, col);
	if(obj!=PEN && obj!=POINT && obj!=ERASE
		&& obj!=SPRAY && obj!=OPT && obj!=TEXT) {
		drawfunc(XtDisplay(canvas), XtWindow(w), copyGC,
			sx,sy,ex,ey);
		if(w==canvas)
			drawfunc(XtDisplay(canvas), canvas_store, copyGC,
				canvas_x+sx, canvas_y+sy, canvas_x+ex, canvas_y+ey);
	}
	if(obj==OPT) {
		drawfunc(XtDisplay(canvas), XtWindow(w), copyGC,
			sx, sy, ex,ey);
		if(w==canvas)
			drawfunc(XtDisplay(canvas), canvas_store, copyGC,
				canvas_x+sx, canvas_y+sy, canvas_x+ex, canvas_y+ey);
	}
}

void Drag(Widget w, XEvent *eve, String *parms, Cardinal *num_parm)
{
	int i,dx,dy,num=10;
	int x,y;

	x  = ex;
	y  = ey;
	ex = eve->xbutton.x;
	ey = eve->xbutton.y;

	next_seed();

	if(obj==OPT || obj==TEXT)
		return;

	if(obj==SPRAY) {
		XSetForeground(XtDisplay(canvas), copyGC, col);

		drawfunc(XtDisplay(canvas), XtWindow(w), copyGC,
			ex, ey, ex, ey);
		if(w==canvas)
			drawfunc(XtDisplay(canvas), canvas_store, copyGC,
				canvas_x+ex, canvas_y+ey, canvas_x+ex, canvas_y+ey);
	}
	else
	if(obj==POINT) {
		XSetForeground(XtDisplay(canvas), copyGC, col);

		draw_line(XtDisplay(canvas), XtWindow(w), copyGC,
			x, y, ex, ey);
		if(w==canvas)
			draw_line(XtDisplay(canvas), canvas_store, copyGC,
				canvas_x+sx, canvas_y+sy, canvas_x+ex, canvas_y+ey);
		sx = ex;
		sy = ey;
	}
	else
	if(obj==PEN || obj==ERASE) {
		XSetForeground(XtDisplay(canvas), copyGC, col);

        dx = (sx-ex);
		dy = (sy-ey);

		if(abs(dx)>abs(dy))
			num = dx/2;
		else
			num = dy/2;

		num = abs(num);
		x = ex;	y = ey;
		i = 0;
        for(i=0;i<num;i++) {
            x = ex+dx*i/num;
            y = ey+dy*i/num;
            drawfunc(XtDisplay(canvas), XtWindow(w), copyGC,
                x, y, ex,ey);
            if(w==canvas)
                drawfunc(XtDisplay(canvas), canvas_store, copyGC,
					canvas_x+x, canvas_y+y, canvas_x+ex, canvas_y+ey);
        }

		drawfunc(XtDisplay(canvas), XtWindow(w), copyGC,
			ex, ey, ex, ey);
		if(w==canvas)
			drawfunc(XtDisplay(canvas), canvas_store, copyGC,
				canvas_x+sx, canvas_y+sy, canvas_x+ex, canvas_y+ey);
		sx = ex;
		sy = ey;
	}
	else {
		XSetForeground(XtDisplay(canvas), xorGC, col);

		drawfunc(XtDisplay(canvas), XtWindow(w), xorGC,
			sx,sy,x,y);
		drawfunc(XtDisplay(canvas), XtWindow(w), xorGC,
			sx,sy,ex,ey);

		if(w==canvas) {
			drawfunc(XtDisplay(canvas), canvas_store, xorGC,
				canvas_x+sx, canvas_y+sy, canvas_x+ex, canvas_y+ey);
			drawfunc(XtDisplay(canvas), canvas_store, xorGC,
				canvas_x+sx, canvas_y+sy, canvas_x+ex, canvas_y+ey);
		}
	}
}

void Paste(Widget w, XEvent *eve, String *parms, Cardinal *num_parm)
{
	int x,y;

	/*
	printf("Paste:\n");
	*/
	if(image_buffer==(XImage*)NULL) {
		return;
	}

	x = eve->xbutton.x;
	y = eve->xbutton.y;
	
	XPutImage(dpy,XtWindow(w),copyGC,image_buffer,
		0,0,x,y,image_buffer->width,image_buffer->height);
	if(w==canvas) {
		/*
		XPutImage(dpy,canvas_store,copyGC,image_buffer,
			0,0,x,y,image_buffer->width,image_buffer->height);
		*/
		XPutImage(dpy,canvas_store,copyGC,image_buffer,
			0,0,canvas_x+x,canvas_y+y,image_buffer->width,image_buffer->height);
	}
}

void Cut(Widget w, XEvent *eve, String *parms, Cardinal *num_parm)
{
	ex = sx = eve->xbutton.x;
	ey = sy = eve->xbutton.y;

	XSetForeground(XtDisplay(canvas), xorGC, col);
	draw_rect(dpy,XtWindow(w),xorGC,sx,sy,ex,ey);
}

void CutDrag(Widget w, XEvent *eve, String *parms, Cardinal *num_parm)
{
	XSetForeground(XtDisplay(canvas), xorGC, col);
	draw_rect(dpy,XtWindow(w),xorGC,sx,sy,ex,ey);

	ex = eve->xbutton.x;
    ey = eve->xbutton.y;

	draw_rect(dpy,XtWindow(w),xorGC,sx,sy,ex,ey);
}

void CutDone(Widget w, XEvent *eve, String *parms, Cardinal *num_parm)
{
	XSetForeground(XtDisplay(canvas), xorGC, col);
	draw_rect(dpy,XtWindow(w),xorGC,sx,sy,ex,ey);

	if(image_buffer!=(XImage*)NULL)
		XDestroyImage(image_buffer);
	image_buffer = XGetImage(dpy,XtWindow(w),
		sx,sy,ex-sx,ey-sy,AllPlanes,ZPixmap);
}
