/*

	SP: Paint progam
		----- Sample for Xt -----

        by  k-chinen@is.aist-nara.ac.jp , 1994

	$Id$
*/

#include "sp.h"

#include <X11/Xaw/Porthole.h>
#include <X11/extensions/shape.h>


XtActionsRec action_list[] = {
    {"draw",    	Draw},
    {"drag",    	Drag},
    {"done",    	Done},
    {"halt",    	Halt},
	{"paste",		Paste},
	{"cut",			Cut},
	{"cutdrag",		CutDrag},
	{"cutdone",		CutDone},
    {"redraw",  	Redraw_canvas},
    };

static Widget dmf;
static Widget cr;
static Widget pp;

Visual *vis;

void init()
{
	int	splitpanel = 1;

	int wcol = 21;
	int	i;
	int wlen = 0;

	int __x,__y;

    dpy = XtDisplay( toplevel );
    /*
    memcpy(&scr, XtScreen( toplevel ), sizeof(scr));
    */
	scr = DefaultScreen(dpy);
    root = DefaultRootWindow(dpy);
	vis = DefaultVisual(dpy,scr);


    black = BlackPixel(dpy, scr);
    white = WhitePixel(dpy, scr);
    copyGC= XtGetGC( toplevel, (unsigned long) NULL, NULL);
	/*
    xorGC= XtGetGC( toplevel, (unsigned long) NULL, NULL);
	*/
	xorGC = XCreateGC(dpy, root,
		(unsigned long) NULL, NULL);
	XSetFunction(dpy, xorGC, GXxor);
	orGC = XCreateGC(dpy, root,
		(unsigned long) NULL, NULL);
	XSetFunction(dpy, orGC, GXor);


	XSetFillStyle(dpy,copyGC,FillSolid);
	XSetFillStyle(dpy,xorGC,FillSolid);
	XSetFillStyle(dpy,orGC,FillSolid);

    cmap = DefaultColormap( dpy, scr);

	switch(vis->class) {
	case GrayScale:
	case StaticGray:
				color_value[0].pixel = black;
				color_value[1].pixel = white;
				lastcolor = 2;
				break;
	default:
				read_colorfile();
				break;
	}

	obj = PEN;

	PASS(1.0);

	read_markform();

	read_formfiles(pen_fname, &lastpen, pen_width, pen_height, pen_pix);
	read_formfiles(fill_fname, &lastfill, fill_width, fill_height, fill_pix);

	pen = 0;
	fill = 0;
	PASS(1.1);

	font = XLoadFont(dpy, "fixed");
	XSetFont(dpy,copyGC,font);
	XSetFont(dpy,xorGC,font);
	XSetFont(dpy,orGC,font);


    canvas_store = XCreatePixmap(dpy, root,
		CANVAS_MAXWIDTH, CANVAS_MAXHEIGHT, COLOR_DEPTH);

	canvas_base = XtVaCreateManagedWidget(
		"Canvasbase", formWidgetClass, toplevel, NULL);

	canvas = XtVaCreateManagedWidget(
		"Canvas", boxWidgetClass, canvas_base, NULL);
	/* */
	clearpixmap(XtDisplay(canvas), canvas_store, copyGC, white,
		0, 0, CANVAS_MAXWIDTH, CANVAS_MAXHEIGHT);
	/* */
	PASS(1.15);
	/* */
	XtVaSetValues(canvas,
		XtNwidth, canvas_width,
		XtNheight, canvas_height,
		XtNforeground, black,
		XtNbackground, white,
		NULL);
	/* */

	canvas_hscroll = XtVaCreateManagedWidget(
		"Canvas", scrollbarWidgetClass, canvas_base,
		XtNorientation, XtorientHorizontal,
		XtNwidth,		canvas_width,
		XtNfromVert,	canvas,
		NULL);
	XtAddCallback(canvas_hscroll, XtNjumpProc,	Jump_canvas,	NULL);
	XtAddCallback(canvas_hscroll, XtNscrollProc,Scroll_canvas,	NULL);
	canvas_vscroll = XtVaCreateManagedWidget(
		"Canvas", scrollbarWidgetClass, canvas_base,
		XtNorientation, XtorientVertical,
		XtNheight,		canvas_height,
		XtNfromHoriz,	canvas,
		NULL);
	XtAddCallback(canvas_vscroll, XtNjumpProc,	Jump_canvas,	NULL);
	XtAddCallback(canvas_vscroll, XtNscrollProc,Scroll_canvas,	NULL);

	if(splitpanel) {
		panel_shell = XtAppCreateShell(
			"Sp","PanelShell",
			topLevelShellWidgetClass,XtDisplay(toplevel),
			NULL,0);
		XtVaSetValues(panel_shell,
			XtNtitle, "Panel of SP",
			NULL);

		panel = XtVaCreateManagedWidget(
			"Panel", formWidgetClass, panel_shell, NULL);
		XtVaSetValues(panel,
			XtNwidth,	1000,
			XtNheight,  1000,
			XtNresize, False,
			XtNresizable, True,
			NULL);
	}
	else {
		panel = XtVaCreateManagedWidget(
			"Panel", formWidgetClass, canvas_base, NULL);
		XtVaSetValues(panel,
			XtNwidth,	1000,
			XtNheight,  1000,
			XtNresize, 	False,
			XtNresizable, True,
			XtNfromVert,canvas_hscroll,
			NULL);
	}

	comlist = XtVaCreateManagedWidget(
		"Com", boxWidgetClass, panel, NULL);
	XtVaSetValues(comlist,
		XtNorientation, XtEhorizontal,
		/*
		XtNhSpace, 0, XtNvSpace, 0,
		*/
		XtNborderWidth, 0,
		/*
		XtNwidth, canvas_width,
		XtNheight, canvas_height,
		*/
		NULL);

	comlabel = XtVaCreateManagedWidget(
		"Comlabel", labelWidgetClass, comlist, NULL);
	XtVaSetValues(comlabel,
		XtNlabel, "Command",
		XtNwidth, 100,
		XtNborderWidth, 0,
		NULL);

	PASS(1.3);
	quit = XtVaCreateManagedWidget(
		"Quit", commandWidgetClass, comlist, NULL);
	XtAddCallback(quit, XtNcallback, Quit_program, NULL);

	load = XtVaCreateManagedWidget(
		"Load", commandWidgetClass, comlist, NULL);
	XtAddCallback(load, XtNcallback, Load_canvas, NULL);

	save = XtVaCreateManagedWidget(
		"Save", commandWidgetClass, comlist, NULL);
	XtAddCallback(save, XtNcallback, Save_canvas, NULL);

	/*
	print = XtVaCreateManagedWidget(
		"*Print", commandWidgetClass, comlist, NULL);
	*/

	exportmonoeps = XtVaCreateManagedWidget(
		"MonoEPS", commandWidgetClass, comlist, NULL);
	XtAddCallback(exportmonoeps, XtNcallback, Export_MONOeps, NULL);

	exportcoloreps = XtVaCreateManagedWidget(
		"ColorEPS", commandWidgetClass, comlist, NULL);
	XtAddCallback(exportcoloreps, XtNcallback, Export_COLOReps, NULL);

	clearcanvas = XtVaCreateManagedWidget(
		"Clear", commandWidgetClass, comlist, NULL);
	XtAddCallback(clearcanvas, XtNcallback, Clear_canvas, NULL);

	solidfillcanvas = XtVaCreateManagedWidget(
		"Fill", commandWidgetClass, comlist, NULL);
	XtAddCallback(solidfillcanvas, XtNcallback, Solidfill_canvas, NULL);
	XtVaSetValues(solidfillcanvas,
		XtNlabel, "SFill",
		NULL);

	fillcanvas = XtVaCreateManagedWidget(
		"Fill", commandWidgetClass, comlist, NULL);
	XtVaSetValues(fillcanvas,
		XtNlabel, "Fill",
		NULL);
	XtAddCallback(fillcanvas, XtNcallback, Fill_canvas,NULL);

	sample = XtVaCreateManagedWidget(
		"Twindow", commandWidgetClass, comlist, NULL);
	XtVaSetValues(sample,
		XtNlabel, "Tranning",
		NULL);
	XtAddCallback(sample, XtNcallback, Wake_sample,NULL);


	pickwindow = XtVaCreateManagedWidget(
		"Pwindow", commandWidgetClass, comlist, NULL);
	XtVaSetValues(pickwindow,
		XtNlabel, "PWin",
		NULL);
	XtAddCallback(pickwindow, XtNcallback, Pickwindow,NULL);

	cutimage = XtVaCreateManagedWidget(
		"Cut", commandWidgetClass, comlist, NULL);
	XtVaSetValues(cutimage,
		XtNlabel, "Cut",
		NULL);
	XtAddCallback(cutimage, XtNcallback, Cutimage,NULL);

	pasteimage = XtVaCreateManagedWidget(
		"Paste", commandWidgetClass, comlist, NULL);
	XtVaSetValues(pasteimage,
		XtNlabel, "Paste",
		NULL);
	XtAddCallback(pasteimage, XtNcallback, Pasteimage,NULL);

	pickcolor = XtVaCreateManagedWidget(
		"Pcolor", commandWidgetClass, comlist, NULL);
	XtVaSetValues(pickcolor,
		XtNlabel, "PColor",
		NULL);
	XtAddCallback(pickcolor, XtNcallback, Pickcolor,NULL);

    objlist = XtVaCreateManagedWidget(
        "Olist", boxWidgetClass, panel, NULL);
    XtVaSetValues(objlist,
        XtNorientation, XtEhorizontal,
        /*
        XtNhSpace, 0, XtNvSpace, 0,
        */
        XtNborderWidth, 0,
        XtNfromVert, comlist,
        NULL);
    objlabel = XtVaCreateManagedWidget(
        "Objlabel", labelWidgetClass, objlist, NULL);
    XtVaSetValues(objlabel,
        XtNlabel, "Objects",
        XtNwidth, 100,
        XtNborderWidth, 0,
        NULL);

    for(i=0;i<N_OBJ;i++){
        ele_obj[i] = XtVaCreateManagedWidget(
            "Obj", boxWidgetClass, objlist, NULL);
        XtVaSetValues(ele_obj[i],
            XtNborderWidth, 0,
            XtNhSpace, 0, XtNvSpace, 0,
            /*
            XtNorientation, XtEhorizontal,
            */
            NULL);

        ele_obj_edit[i] = XtVaCreateManagedWidget(
            "Obj", commandWidgetClass, ele_obj[i], NULL);
        XtVaSetValues(ele_obj_edit[i],
            XtNborderWidth, 0,
            /*
            XtNlabel, "E",
            */
            XtNbitmap, edit_mark,
            /*
            XtNwidth, 10,
            XtNheight,10,
            */
            XtNforeground,black,
            XtNbackground,white,
            NULL);
        XtAddCallback(ele_obj_edit[i], XtNcallback, Editobj, (XtPointer)i);

        ele_obj_label[i] = XtVaCreateManagedWidget(
            "Obj", commandWidgetClass, ele_obj[i], NULL);
        XtVaSetValues(ele_obj_label[i],
            XtNlabel, objname[i],
            XtNforeground,black,
            XtNbackground,white,
            NULL);
        XtAddCallback(ele_obj_label[i], XtNcallback, Setobj, (XtPointer)i);
    }
    Setobj((Widget) NULL, (XtPointer)((int) obj), (XtPointer) NULL);

	/*
    cr = XtVaCreateManagedWidget(
        "Objlabel", boxWidgetClass, objlist, NULL);
    XtVaSetValues(cr,
        XtNwidth, 100,
        XtNheight, 100,
        XtNborderWidth, 4,
        NULL);
	*/

	PASS(1.5);
	colorlist = XtVaCreateManagedWidget(
		"Clist", formWidgetClass, panel, NULL);
	XtVaSetValues(colorlist,
		XtNorientation, XtEhorizontal,
		/*
		XtNwidth, canvas_width,
		*/
		XtNwidth, 1000,
		XtNheight, canvas_height,
		XtNfromVert, objlist,
		XtNborderWidth, 0,
		NULL);

	colorlabel = XtVaCreateManagedWidget(
		"Colorlabel", labelWidgetClass, colorlist, NULL);
	XtVaSetValues(colorlabel,
		XtNborderWidth, 0,
		XtNlabel, "Colors",
		XtNwidth, 100,
		NULL);

	dmf = XtVaCreateManagedWidget(
		"Nowcolor", boxWidgetClass, colorlist, NULL);
	XtVaSetValues(dmf,
		XtNborderWidth, 0,
		XtNwidth,		(100-select_mark_width*2)/2-8,
		XtNheight,		select_mark_height*2-2,
		XtNfromVert,	colorlabel,
		NULL);

	nowcolor = XtVaCreateManagedWidget(
		"Nowcolor", boxWidgetClass, colorlist, NULL);
	XtVaSetValues(nowcolor,
		XtNborderWidth, 1,
		XtNwidth,		select_mark_width*2-2,
		XtNheight,		select_mark_height*2-2,
		XtNfromHoriz,	dmf,
		XtNfromVert,	colorlabel,
		NULL);

	/*
	printf("lastcolor=%d\n",lastcolor);
	*/

	for(i=0;i<lastcolor;i++){
		ele_color[i] = XtVaCreateManagedWidget(
			"Col", commandWidgetClass, colorlist, NULL);
		XtVaSetValues(ele_color[i],
			XtNbackground, color_value[i].pixel,
			XtNlabel, "",
			XtNborderWidth, select_mark_width/2,
			XtNborderColor, color_value[i].pixel,
			XtNwidth, select_mark_width,
			XtNheight, select_mark_height,
			XtNhighlightThickness, 0,
			NULL);
		/* */
		if(i<wcol) {
			if(i==0)
				XtVaSetValues(ele_color[i],
					XtNfromHoriz, colorlabel,
					NULL);
			else
				XtVaSetValues(ele_color[i],
					XtNfromHoriz, ele_color[i-1],
					NULL);
		}
		else
		if(i % wcol == 0) {
			XtVaSetValues(ele_color[i],
				XtNfromHoriz, colorlabel,
				XtNfromVert, ele_color[i-wcol],
				NULL);
		}
		else {
			XtVaSetValues(ele_color[i],
				XtNfromVert, ele_color[i-wcol],
				XtNfromHoriz, ele_color[i-1],
				NULL);
		}
		/* */
		/*
		putchar('-');
		XtVaSetValues(ele_color[i],
			XtNx,	100+4 + (i%wcol)*(select_mark_width*2+4),
			XtNy,		4 + (i/wcol)*(select_mark_height*2+4),
			NULL);
		*/
		XtAddCallback(ele_color[i], XtNcallback, Setcolor, (XtPointer)i );
	}

	filllist = XtVaCreateManagedWidget(
		"Filllist", boxWidgetClass, panel, NULL);
	XtVaSetValues(filllist,
		XtNorientation, XtEhorizontal,
		XtNfromVert, colorlist,
		/*
		XtNhSpace, 0, XtNvSpace, 0,
		*/
		XtNborderWidth, 0,
		NULL);
	filllabel = XtVaCreateManagedWidget(
		"Filllabel", labelWidgetClass, filllist, NULL);
	XtVaSetValues(filllabel,
		XtNlabel, "FillStyles",
		XtNwidth, 100,
		XtNborderWidth, 0,
		NULL);
	for(i=0;i<lastfill;i++){
		ele_fill[i] = XtVaCreateManagedWidget(
			"Fill", toggleWidgetClass, filllist, NULL);
		XawToggleChangeRadioGroup(ele_fill[i],ele_fill[0]);
		XtVaSetValues(ele_fill[i],
			XtNlabel, "",
			XtNwidth, 30, XtNheight, 30,
			XtNforeground,black,
			XtNbackground,white,
			/* */
			XtNbitmap, fill_pix[i],
			/* */
			/* 
			XtNbackgroundPixmap, tile_pix[i],
			*/
			NULL);
		XtAddCallback(ele_fill[i], XtNcallback, Setfill, (XtPointer)i);
	}
	XtVaSetValues(ele_fill[0],XtNstate,True,NULL);
	PASS(1.8);

	penlist = XtVaCreateManagedWidget(
		"Penlist", boxWidgetClass, panel, NULL);
	XtVaSetValues(penlist,
		XtNorientation, XtEhorizontal,
		XtNfromVert, filllist,
		XtNborderWidth, 0,
		NULL);
	penlabel = XtVaCreateManagedWidget(
		"Penlabel", labelWidgetClass, penlist, NULL);
	XtVaSetValues(penlabel,
		XtNlabel, "PenStyles",
		XtNwidth, 100,
		XtNborderWidth, 0,
		NULL);
	PASS(2);
	for(i=0;i<lastpen;i++){
		ele_pen[i] = XtVaCreateManagedWidget(
			"Pens", toggleWidgetClass, penlist, NULL);

		XawToggleChangeRadioGroup(ele_pen[i],ele_pen[0]);

		XtVaSetValues(ele_pen[i],
			XtNlabel, "",
			XtNwidth, 30, XtNheight, 30,
			XtNforeground,black,
			XtNbackground,white,
			XtNbitmap, pen_pix[i],
			NULL);
		XtAddCallback(ele_pen[i], XtNcallback, Setpen, (XtPointer)i);
	}
	PASS(3.0);
	XtVaSetValues(ele_pen[0],XtNstate,True,NULL);

	/*
	XtVaSetValues(panel,
		XtNwidth, canvas_width,
		XtNresize, False,
		NULL);
	*/

	/*
	XtVaSetValues(panel,XtNheight,1000,NULL);
	*/

	XtAppAddActions(app_context, action_list, XtNumber(action_list));
	XtOverrideTranslations(canvas,XtParseTranslationTable(canvas_trans));
    XtRealizeWidget(toplevel);

	if(splitpanel)
		XtRealizeWidget(panel_shell);

	/*
	wcol = (wlen-100)/(select_mark_width*2);
	for(i=0;i<lastcolor;i++) {
		putchar('-');
		XtVaSetValues(ele_color[i],
			XtNx,	100+4 + (i%wcol)*(select_mark_width*2+4),
			XtNy,		4 + (i/wcol)*(select_mark_height*2+4),
			NULL);
	}
	*/

	/*
	XtVaGetValues(comlist,XtNwidth,&i,NULL);
	if(wlen<i) wlen=i;
	XtVaGetValues(objlist,XtNwidth,&i,NULL);
	if(wlen<i) wlen=i;

	printf("now wlen=%d\n",wlen);
	printf("now wcol=%d lastcolor=%d\n",wcol,lastcolor);
	*/
	/*
	wcol = (wlen-100)/(select_mark_width*2);
	printf("change to wcol=%d\n",(wlen-100)/(select_mark_width*2+4));
	*/
	/*
	wlen = wlen + 20;
	XtVaSetValues(panel,XtNwidth,wlen,NULL);
	*/

	ncol = old_col = col = lastcolor/2;
	Setcolor(ele_color[old_col], (XtPointer) col, (XtPointer) NULL);
	PASS(4.0);

    sample_shell = XtAppCreateShell(
        "Sp","SampleShell",
        topLevelShellWidgetClass,XtDisplay(toplevel),
        NULL,0);
	XtVaSetValues(sample_shell,
		XtNtitle, "Sample",
		NULL);
    sample_base = XtVaCreateManagedWidget(
        "SampleBase", formWidgetClass, sample_shell, NULL);
    sample_canvas = XtVaCreateManagedWidget(
        "SampleBase", boxWidgetClass, sample_base, NULL);
    sample_clear = XtVaCreateManagedWidget(
        "Clear", commandWidgetClass, sample_base, NULL);
	XtVaSetValues(sample_clear,
		XtNfromVert, sample_canvas,
		NULL);
	XtVaSetValues(sample_canvas,
		XtNwidth, 200,
		XtNheight, 200,
		NULL);
	XtAddCallback(sample_clear ,
		XtNcallback, Clearsample, NULL);

	XtOverrideTranslations(sample_canvas,XtParseTranslationTable(canvas_trans));

	textshell = XtVaCreatePopupShell(
        "textshell", transientShellWidgetClass,
        toplevel, NULL);
	XtVaSetValues(textshell,
		XtNlabel,	"Text Shell",
		NULL);
	XtMoveWidget(textshell,
		DisplayWidth(dpy,scr)/2, DisplayHeight(dpy,scr)*2/3);

	textentry =  XtVaCreateManagedWidget(
        "textentry", dialogWidgetClass,  
        textshell, NULL);           
	XtVaSetValues(textentry,
		XtNlabel,	"ENTER STRING",
		XtNvalue,	"ABC",
		NULL);
	/*
	XtOverrideTranslations(
		(DialogWidget)textentry->composite.children[1],
		XtParseTranslationTable(text_trans));
	*/



	donetextentry =  XtVaCreateManagedWidget(
        "textentry", commandWidgetClass,  
        textentry, NULL);           
	XtVaSetValues(donetextentry,
		XtNlabel,	"Done",
		NULL);

	XtAddCallback(donetextentry,
		XtNcallback, Done_textentry, NULL);


    file_name_shell = XtVaCreatePopupShell(
        "textshell", transientShellWidgetClass,
        toplevel, NULL);
    XtVaSetValues(file_name_shell,
        XtNlabel,   "Text Shell",
        NULL);
	XtMoveWidget(file_name_shell,
		DisplayWidth(dpy,scr)/2, DisplayHeight(dpy,scr)*1/3);
	

    file_name_entry =  XtVaCreateManagedWidget(
        "textentry", dialogWidgetClass,
        file_name_shell, NULL);
    XtVaSetValues(file_name_entry,
        XtNlabel,   "ENTER FILENAME",
        XtNvalue,   "ABC",
        NULL);

    done_file_name_entry =  XtVaCreateManagedWidget(
        "textentry", commandWidgetClass,
        file_name_entry, NULL);
    XtVaSetValues(done_file_name_entry,
        XtNlabel,   "Done",
        NULL);

    XtAddCallback(done_file_name_entry,
        XtNcallback, Done_export_eps, NULL);

    cancel_file_name_entry =  XtVaCreateManagedWidget(
        "textentry", commandWidgetClass,
        file_name_entry, NULL);
    XtVaSetValues(cancel_file_name_entry,
        XtNlabel,   "Cancel",
        NULL);

    XtAddCallback(cancel_file_name_entry,
        XtNcallback, Canel_export_eps, NULL);

	/* EXTERNAL initalize routine call */
	init_edit_spray();
	init_load();
}
