/*

    SP: Paint progam
        ----- Sample for Xt -----

        by  k-chinen@is.aist-nara.ac.jp , 1994

    $Id$
*/


/*
 * Note: 
 *      - <iida> He tell me how to read NeXT's header files.
 */


#include "sp.h"

#include <X11/Xaw/List.h>
#include <X11/Xaw/Viewport.h>

#include <X11/extensions/shape.h>

#ifdef BSD
#include <sys/types.h>
#include <sys/dirs.h>
#define dirent direct
#else
#ifdef NeXT
#include <sys/dirent.h>
#include <sys/dir.h>
#else
#include <dirent.h>
#endif
#endif
#include <sys/stat.h>

#define LISTMAX 200

static Widget	shell,base;
static Widget	cancel,home,current,label;
static Widget	down,up;
static Widget	list;

static String	l[LISTMAX];
static int		lnum=0;
static char 	pwd[BUFSIZ];

char		*client_name="SP";


void Error(char *message, char *qualifier)
{
	(void) fprintf(stderr,"%s: %s",client_name,message);
	if (qualifier != (char *) NULL)
		(void) fprintf(stderr," (%s)",qualifier);
	(void) fprintf(stderr,".\n");

	exit(1);
}



#define PARENT "<PARENT>"


int collect_pathlist(char *path, int *lnum, String list[])
{
	DIR	*dirp;
	struct dirent *dp;
	int i;

	for(i=0;i<LISTMAX;i++)
	{
		free(list[i]);
		/*
		list[i] = NULL;
		*/
	}

	dirp = opendir(path);
	i = 0;
	while((i<LISTMAX) && (dp=readdir(dirp))!=NULL) {
		if(dp->d_name[0]!='.') {
			list[i] = (char*)malloc(sizeof(char)*(strlen(dp->d_name)+1));
			strcpy(list[i],dp->d_name);
			i++;
		}
		else	
		if(dp->d_name[1]=='.') {
			list[i] = (char*)malloc(sizeof(char)*(strlen(PARENT)+1));
			strcpy(list[i],PARENT);
			i++;
		}
	}
	closedir(dirp);

	*lnum = i;
	/*
	printf("read %2d in %s\n",*lnum,path);
	*/

	return 0;
}



void Cancel(Widget w, XtPointer client_data, XtPointer call_data)
{
	XtPopdown(shell);
}

void Home(Widget w, XtPointer client_data, XtPointer call_data)
{
	char *p;

	p = getenv("HOME");
	if(p!=NULL) {
		strcpy(pwd,p);
		strcat(pwd,"/");
	}
	else
		strcpy(pwd,"./");

	collect_pathlist(pwd,&lnum,l);

	XtVaSetValues(list,
		XtNlist, 			l,
		XtNnumberStrings,	lnum,
		NULL);
	XtVaSetValues(label,
		XtNlabel, 			pwd,
		NULL);
	/*
	XawListChange(list,l,-1,-1,True);
	*/
	XawListChange(list,l,lnum,150,True);
}

void Current(Widget w, XtPointer client_data, XtPointer call_data)
{
	char *p;

	p = getenv("PWD");
	if(p!=NULL) {
		strcpy(pwd,p);
		strcat(pwd,"/");
	}
	else
		strcpy(pwd,"./");

	collect_pathlist(pwd,&lnum,l);

	XtVaSetValues(list,
		XtNlist, 			l,
		XtNnumberStrings,	lnum,
		NULL);
	XtVaSetValues(label,
		XtNlabel, 			pwd,
		NULL);
	/*
	XawListChange(list,l,-1,-1,True);
	*/
	XawListChange(list,l,lnum,150,True);
}


/*
void Load(Widget w, XtPointer client_data, XtPointer call_data)
{
	fprintf(stderr,"Sorry, Load() is empty !!!\n");
	return ;
}
*/


void Load(Widget w, XtPointer client_data, XtPointer call_data)
{
	XawListReturnStruct *listret;
	char *p;
	struct stat	st;
	char tmp[BUFSIZ];

	XImage *tmp_image;

	listret = XawListShowCurrent(list);

	strcpy(tmp,pwd);
	/* --- if Parent selected, remove last field from Path --- */
	if(listret->list_index==0) {
		if(strlen(pwd)>1) {
			p = tmp;
			while(*p++)
				;
			p--;
			p--;
			do{
				p--;
			} while(*p!='/');
			p++;
			*p='\0';
		}
	}
	else {
		strcat(tmp,listret->string);
		strcat(tmp,"/");
	}

	/*
	fprintf(stderr,"Select %s, at %d\n",listret->string,listret->list_index);
	*/

	stat(tmp,&st);
	if(st.st_mode & S_IFDIR) {
		strcpy(pwd,tmp);
		collect_pathlist(pwd,&lnum,l);

		XtVaSetValues(list,
			XtNlist, 			l,
			XtNnumberStrings,	lnum,
			NULL);
		XtVaSetValues(label,
			XtNlabel, 			pwd,
			NULL);


		/*
		XawListChange(list,l,-1,-1,True);
		*/
		XawListChange(list,l,lnum,150,True);
	}
	else {
		long *buf, *lp;
		int w,h,c;
		int x,y;
		unsigned char *b_buf, *bp;

  extern int ppm_load(Display*,Colormap,char*,int,int,long**,int*,int*,int);

		XtPopdown(shell);

		/* 
		fprintf(stderr,"Select file %s, at %d\n",listret->string,listret->list_index);
		*/

		if(*listret->string==NULL) {
			return;
		}


		XtVaGetValues(canvas,
			XtNwidth,&canvas_width,XtNheight,&canvas_height,NULL);


		bp = (unsigned char*) tmp;
		while(*(bp+1))
			bp++;
		*bp = '\0';

		fprintf(stderr,"Load %s, plase wait...\n",tmp);

		if(ppm_load(XtDisplay(canvas), cmap, tmp, 100, 0, &buf,&w,&h,c)) {
			fprintf(stderr,"Cannot load \"%s\"\n",tmp);
			return;
		}

		/*
		printf("Load: OK, I draw pixels (%d x %d)\n",w,h);
		*/

		/* Convert pixel(long) array to byte array */
		c=w*h;
		lp = buf;
		bp = b_buf = (unsigned char*)malloc(sizeof(char)*c);
		while(c) {
			*bp++ = (char) *lp++;
			c--;
		}

		tmp_image = XCreateImage(XtDisplay(canvas),vis,COLOR_DEPTH,ZPixmap,
			0,(char*)b_buf,w,h,COLOR_DEPTH,w*sizeof(char));

		XPutImage(XtDisplay(canvas), XtWindow(canvas), copyGC, tmp_image,
			0,0,0,0,w,h);
		XPutImage(XtDisplay(canvas), canvas_store, copyGC, tmp_image,
			0,0,0,0,w,h);

		free(buf);
		free(b_buf);

		XFlush(XtDisplay(canvas));

		/* CHECK func-"_XDefaultError" */
		return;
	}
}


void Load_canvas(Widget w, XtPointer client_data, XtPointer call_data)
{
	XtPopup(shell, XtGrabNonexclusive);
}

init_load(int argc, char **argv)
{
	int i;
	int qw,hw,cr;
	char *p;

	p = getenv("PWD");
	if(p!=NULL) {
		strcpy(pwd,p);
		strcat(pwd,"/");
	}
	else
		strcpy(pwd,"./");

	/*
    shell = XtAppCreateShell(
        "Sp","EditSpray",
        topLevelShellWidgetClass,XtDisplay(toplevel),
        NULL,0);
	*/
    shell = XtVaCreatePopupShell(
        "Loadshell", transientShellWidgetClass,
        toplevel, NULL);
    XtVaSetValues(textshell,
        XtNlabel,   "Load Shell",
        NULL);

	base = XtVaCreateManagedWidget(
			"Base", formWidgetClass, shell, NULL);
	XtVaSetValues(base,
		XtNwidth,	600,
		XtNheight,	950,
		NULL);

	label = XtVaCreateManagedWidget(
			"Loadlabel", labelWidgetClass, base, NULL);
	XtVaSetValues(label,
		XtNlabel,		pwd,
		XtNwidth,		400,
		XtNborderWidth,	0,
		NULL);

	for(i=0;i<LISTMAX;i++)
		l[i] = NULL;

	collect_pathlist(pwd,&lnum,l);

	list = XtVaCreateManagedWidget(
		"Base", listWidgetClass, base,
		/*
		XtNverticalList,	True,
		*/

		XtNwidth,			400,
		XtNheight,			400,

		XtNlist,			l,
		XtNnumberStrings,	lnum,

		XtNdefaultColumns,	5,

		/* 

		XtNcolumnSpacing,	200,
		XtNrowSpacing,	50,

		XtNinternalHeight,	40,
		XtNinternalWidth,	100,
		*/

		/*
		XtNlongest, 		120,
		*/

		XtNfromVert,		label,
		NULL);
	/*
	XawListChange(list,l,-1,-1,True);
	*/
	XawListChange(list,l,lnum,150,True);

	XtAddCallback(list, XtNcallback, Load,	NULL);

	cancel = XtVaCreateManagedWidget(
			"LoadCancel", commandWidgetClass, base, NULL);
	XtVaSetValues(cancel,
		XtNlabel,		"Cancel",
		XtNfromVert,	list,
		NULL);
	XtAddCallback(cancel, XtNcallback, Cancel,	NULL);

	home = XtVaCreateManagedWidget(
			"Homedir", commandWidgetClass, base, NULL);
	XtVaSetValues(home,
		XtNlabel,		"Home",
		XtNfromVert,	list,
		XtNfromHoriz,	cancel,
		NULL);
	XtAddCallback(home, XtNcallback, Home,	NULL);

	current = XtVaCreateManagedWidget(
			"Curdir", commandWidgetClass, base, NULL);
	XtVaSetValues(current,
		XtNlabel,		"Current",
		XtNfromVert,	list,
		XtNfromHoriz,	home,
		NULL);
	XtAddCallback(current, XtNcallback, Current,	NULL);
}
