/*

	SP: Paint progam
		----- Sample for Xt -----

		by	k-chinen@is.aist-nara.ac.jp , 1994

	$Id: read.c,v 1.1 1993/05/07 01:43:24 k-chinen Exp $
*/

#include "sp.h"

#define _DEBUG_XBM

#ifdef SETUPFILE_PATH
char *setupfile_path = SETUPFILE_PATH;
#else
char *setupfile_path = "/usr/local/lib/sp";
#endif

char *color_fname   = "sp_color.lst";
char *pen_fname     = "sp_pen.lst";
char *fill_fname    = "sp_fill.lst";

char *set_fname(char *out, char *ref)
{
	if(*setupfile_path!=NULL) {
		sprintf(out, "%s/%s",setupfile_path,ref);
	}
	else {
		strcpy(out, ref);
	}
#ifdef DEBUG
	printf("set_fname:%s\n",out);
#endif
	return out;
}

void read_colorfile()
{
	FILE *color_fp;
	char tmp[STRLEN];
	int	i,j;
	XColor c1,c2;

	if((color_fp=fopen(set_fname(tmp,color_fname),"r"))==NULL) {
		fprintf(stderr,"Cannot open color list file , %s.\n",tmp);
		exit(1);
	}
	
	j=0;
	for(i=0;i<N_COLOR;i++) {
		if(fgets(tmp,STRLEN,color_fp)==NULL)
			break;
		if(strlen(tmp)>1) {
			tmp[(int)strlen(tmp)-1] = '\0';
			if(XAllocNamedColor(dpy,cmap,tmp,&c1,&c2)) {
				color_value[j] = c1;
#ifdef DEBUG
				printf("Alocate %7d\n",color_value[j].pixel);
				fflush(stdout);
#endif
				j++;
			}
		}
	}
	lastcolor=j;
}

void read_markform()
{
	select_mark = XCreatePixmapFromBitmapData(dpy, root,
		select_mark_bits, select_mark_width, select_mark_height,
		black ,white ,COLOR_DEPTH);
	edit_mark = XCreatePixmapFromBitmapData(dpy, root,
		edit_mark_bits, edit_mark_width, edit_mark_height,
		black ,white ,COLOR_DEPTH);
}

void read_formfiles(char *list_fname,
	int *last, unsigned int width[], unsigned int height[], Pixmap pix[])
{
	FILE *list_fp;
	char tmp[STRLEN];
	char name[STRLEN];
	int	i,j;
	int	dx,dy;

	if((list_fp=fopen(set_fname(tmp,list_fname),"r"))==NULL) {
		fprintf(stderr,
			"read_formfiles: cannot open from list file [%s]\n",list_fname);
		exit(1);
	}
	
	j=0;
	for(i=0;i<N_PEN;i++) {
		if(fgets(tmp,STRLEN,list_fp)==NULL) {
			break;
		}
		if(strlen(tmp)>1) {
			/* set EOS at last */
			tmp[(int)strlen(tmp)-1] = '\0';
#ifdef DEBUG_XBM
			printf("$ form %2d: name [%s]\n",j,tmp);
#endif
			if(XReadBitmapFile(dpy,root,set_fname(name,tmp),
					&width[j],&height[j],&pix[j], &dx, &dy)) {
				fprintf(stderr,
					"read_formfiles: cannot open file [%s]\n",name);
			}
			else {
				/* next */
				j++;
			}
		}
	}
	*last = j;
#ifdef DEBUG_XBM
	printf("read_formfiles: last=%d , %s complate...\n",*last,tmp);
	fflush(stdout);
#endif

	if(*last==0) {
		puts("No form files");
		exit(4);
	}
	PASS(0.4);
}
