/*

	SP: Paint progam
		----- Sample for Xt -----

		by	cnn

	$Id: sp.h,v 1.1 1993/05/07 01:49:14 k-chinen Exp $
*/

/* --- Standerd C Librarys */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

/* --- X window system (Xlib) */
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/cursorfont.h>

#include <X11/Xmu/WinUtil.h>

/* --- X window system, Xtoolkit (Xt), Athena widget set (Xaw) */
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Toggle.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Dialog.h>
#include <X11/Xaw/Scrollbar.h>

/* --- Mark style with X bitmap (XBM) format */
#include "./marks/select_mark.xbm"
#include "./marks/edit_mark.xbm"

#define _DEBUG_XBM
#define _CHECK_PASS

#ifdef CHECK_PASS
#define PASS(x) printf("PASS %f\n", x); fflush(stdout)
#else
#define PASS(x)	(void)x
#endif

#define CANVAS_MAXWIDTH		2000
#define CANVAS_MAXHEIGHT	2000
#define CANVAS_WIDTH		500
#define CANVAS_HEIGHT		500
#define COLOR_DEPTH			(XDefaultDepth(dpy,scr))

#define N_OBJ	12
#define N_COLOR	100
#define N_FILL	20
#define N_PEN	20

#define STRLEN	256

extern Dimension canvas_x, canvas_y;
extern Dimension canvas_width, canvas_height;

typedef enum {
	PEN=0, POINT, ERASE, SPRAY, LINE, TEXT,
	RECT, CIR, ELL, FRECT, FCIR, FELL, OPT } objtype;

extern char *objname[];

extern char *setupfile_path;
extern char *color_fname, *pen_fname, *fill_fname;

extern Display *dpy;
extern Window	root; 

extern Pixmap	canvas_store;
extern XImage	*image_buffer;

extern GC		copyGC, xorGC, orGC;
extern Colormap cmap;
extern Pixel	black, white;
extern int 	scr;

extern XtAppContext app_context;
extern String canvas_trans;

extern Pixmap	select_mark;
extern Pixmap	edit_mark;

extern Widget	toplevel, canvas_base;
extern Widget	canvas;
extern Widget	canvas_hscroll, canvas_vscroll;

extern Widget 	panel;

extern Widget	comlabel;
extern Widget	comlist;
extern Widget	quit, load, save;
extern Widget	clearcanvas, solidfillcanvas, fillcanvas, sample;
extern Widget	pickwindow, cutimage, pasteimage;
extern Widget   pickcolor;
extern Widget   print;
extern Widget   exportmonoeps,exportcoloreps;

extern Widget	colorlabel;
extern Widget	colorlist,nowcolor;
extern Widget	ele_color[N_COLOR];
extern XColor	color_value[N_COLOR];
extern int	    lastcolor;
extern Pixel	col,old_col;
extern int		ncol;

extern Widget	objlabel;
extern Widget	objlist;
extern Widget	ele_obj[N_OBJ];
extern Widget	ele_obj_edit[N_OBJ];
extern Widget	ele_obj_label[N_OBJ];
extern objtype 	obj;

extern Widget	filllabel;
extern Widget	filllist;
extern Widget	ele_fill[N_FILL];
extern Pixmap	fill_pix[N_FILL], tile_pix[N_FILL];
extern int		fill;
extern unsigned int fill_width[N_PEN], fill_height[N_PEN];
extern int 		lastfill;

extern Widget	penlabel;
extern Widget	penlist;
extern Widget	ele_pen[N_PEN];
extern Pixmap	pen_pix[N_PEN];
extern int		pen;
extern unsigned int pen_width[N_PEN], pen_height[N_PEN];
extern	int		lastpen;

extern Bool		indraw;
extern  void 	(*drawfunc)();

extern int		spray_count, spray_size;

extern int sx,sy,ex,ey;
extern int rand_seed;

extern Widget  textshell, textentry, donetextentry;
extern Widget  file_name_shell, file_name_entry,
				done_file_name_entry, cancel_file_name_entry;

extern String text_trans;


extern Widget	panel_shell;
extern Widget	sample_shell, sample_base, sample_canvas, sample_clear;

extern Widget	edit_spray_shell;

extern XtActionsRec action_list[];

extern Font		font;

extern String	filename;

extern Visual *vis;






void read_colorfile();
void read_markform();
void read_formfiles(char *list_fname,int *last,unsigned int width[],unsigned int height[],Pixmap pix[]);
void Quit_program(Widget w,XtPointer client_data,XtPointer call_data);
void Load_canvas(Widget w,XtPointer client_data,XtPointer call_data);
void Save_canvas(Widget w,XtPointer client_data,XtPointer call_data);
void clearpixmap(Display *dpy,Drawable drw,GC gc,int filler,int sx,int sy,int wx,int wy);
void Redraw_canvas(Widget w,XEvent *eve,String *par,Cardinal *npar);
void Clear_canvas(Widget w,XtPointer client_data,XtPointer call_data);
void Solidfill_canvas(Widget w,XtPointer client_data,XtPointer call_data);
void Fill_canvas(Widget w,XtPointer client_data,XtPointer call_data);
void Wake_sample(Widget w,XtPointer client_data,XtPointer call_data);
void draw_pen(Display *d,Window w,GC g,int x,int y,int tx,int ty);
void draw_point(Display *d,Window w,GC g,int x,int y,int tx,int ty);
void draw_erase(Display *d,Window w,GC g,int x,int y,int tx,int ty);
void draw_line(Display *d,Window w,GC g,int x,int y,int nx,int ny);
void draw_rect(Display *d,Window w,GC g,int x,int y,int nx,int ny);
void draw_frect(Display *d,Window w,GC g,int x,int y,int nx,int ny);
void draw_cir(Display *d,Window w,GC g,int x,int y,int nx,int ny);
void draw_fcir(Display *d,Window w,GC g,int x,int y,int nx,int ny);
void draw_ell(Display *d,Window w,GC g,int x,int y,int nx,int ny);
void draw_fell(Display *d,Window w,GC g,int x,int y,int nx,int ny);
void draw_spray(Display *d,Window w,GC g,int x,int y,int tx,int ty);
void draw_text(Display *d,Window w,GC g,int x,int y,int tx,int ty);
void draw_opt(Display *d,Window w,GC g,int x,int y,int tx,int ty);
void Clearsample(Widget w,XtPointer client_data,XtPointer call_data);
void Setcolor(Widget w,XtPointer client_data,XtPointer call_data);
void Setobj(Widget w,XtPointer client_data,XtPointer call_data);

void init_edit_spray();
void start_edit_spray();

void Editobj(Widget w,XtPointer client_data,XtPointer call_data);
void Setpen(Widget w,XtPointer client_data,XtPointer call_data);
void Setfill(Widget w,XtPointer client_data,XtPointer call_data);
void Draw(Widget w,XEvent *eve,String *parms,Cardinal *num_parm);
void Halt(Widget w,XEvent *eve,String *parms,Cardinal *num_parm);
void Done(Widget w,XEvent *eve,String *parms,Cardinal *num_parm);
void Drag(Widget w,XEvent *eve,String *parms,Cardinal *num_parm);
void Paste(Widget w,XEvent *eve,String *parms,Cardinal *num_parm);
void Cut(Widget w,XEvent *eve,String *parms,Cardinal *num_parm);
void CutDrag(Widget w,XEvent *eve,String *parms,Cardinal *num_parm);
void CutDone(Widget w,XEvent *eve,String *parms,Cardinal *num_parm);

int pick_window(Window *w, int *x, int *y);
int pick_color();
void Pickwindow(Widget w,XtPointer client_data,XtPointer call_data);
void Pickcolor(Widget w,XtPointer client_data,XtPointer call_data);

void Done_textentry(Widget w, XtPointer client_data, XtPointer call_data);

void Scroll_canvas(Widget w,XtPointer client_data,XtPointer call_data);
void Jump_canvas(Widget w,XtPointer client_data,XtPointer call_data);

void Cutimage(Widget w,XtPointer client_data,XtPointer call_data);
void Pasteimage(Widget w,XtPointer client_data,XtPointer call_data);

void Done_export_eps(Widget w,XtPointer client_data,XtPointer call_data);
void Canel_export_eps(Widget w,XtPointer client_data,XtPointer call_data);
void Export_MONOeps(Widget w,XtPointer client_data,XtPointer call_data);
void Export_COLOReps(Widget w,XtPointer client_data,XtPointer call_data);

void init();
